import unittest
from eea.monkeypatch import apply_patch


def patched(self):
    """patch replacement"""


class TestClass(object):
    """A test class
    """

    def to_be_patched(self):
        """A method that will be patched"""


class MonkeyPatchTestCase(unittest.TestCase):
    
    def test_apply_patch(self):
        """Test apply_patch"""

        apply_patch(TestClass, 'to_be_patched', patched)
        assert hasattr(TestClass, 'original_to_be_patched')
        assert TestClass.to_be_patched.func_code == patched.func_code

def test_suite():
    suite = unittest.TestLoader().loadTestsFromTestCase(MonkeyPatchTestCase)
    return suite
